<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>app.services &mdash; AIoD Broker 0.01 documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=80d5e7a1" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../_static/copybutton.css?v=76b2166b" />

  
  <!--[if lt IE 9]>
    <script src="../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../_static/documentation_options.js?v=6ca3c713"></script>
        <script src="../../_static/doctools.js?v=9a2dae69"></script>
        <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
        <script src="../../_static/clipboard.min.js?v=a7894cd8"></script>
        <script src="../../_static/copybutton.js?v=f281be69"></script>
        <script src="../../_static/custom.js?v=45d98342"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            AIoD Broker
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../introduction.html">Introduction</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../architecture.html">Architecture</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../context.html">Context Diagram</a></li>
<li class="toctree-l2"><a class="reference internal" href="../../container.html">Container Diagram</a></li>
<li class="toctree-l2"><a class="reference internal" href="../../component.html">Component Diagram</a></li>
<li class="toctree-l2"><a class="reference internal" href="../../data_flow.html">Data Flow Chart</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../setup_deployment.html">Setup/Deployment</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../prerequisites.html">Prerequisites</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../prerequisites.html#aiod-api-installation">AIoD API Installation</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../prerequisites.html#repository-installation">Repository Installation</a></li>
<li class="toctree-l3"><a class="reference internal" href="../../prerequisites.html#configuration">Configuration</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../deployment.html">Docker Deployment</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../deployment.html#service-information">Service Information</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../installation.html">Native Installation</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../installation.html#python-environment-and-nodejs-setup">Python Environment and NodeJS Setup</a><ul>
<li class="toctree-l4"><a class="reference internal" href="../../installation.html#using-virtualenv">Using Virtualenv</a></li>
<li class="toctree-l4"><a class="reference internal" href="../../installation.html#using-conda">Using Conda</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../documentation.html">Documentation</a><ul>
<li class="toctree-l2"><a class="reference internal" href="../../app_services.html">Services</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.add_dataset"><code class="docutils literal notranslate"><span class="pre">add_dataset()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.convert_date_to_iso_format"><code class="docutils literal notranslate"><span class="pre">convert_date_to_iso_format()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.fetch_dataset"><code class="docutils literal notranslate"><span class="pre">fetch_dataset()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.generate_string"><code class="docutils literal notranslate"><span class="pre">generate_string()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.get_platform_id_by_dataset_name"><code class="docutils literal notranslate"><span class="pre">get_platform_id_by_dataset_name()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.keycloak_openid"><code class="docutils literal notranslate"><span class="pre">keycloak_openid()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.logging"><code class="docutils literal notranslate"><span class="pre">logging()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.login"><code class="docutils literal notranslate"><span class="pre">login()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.parse2payload"><code class="docutils literal notranslate"><span class="pre">parse2payload()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.publish"><code class="docutils literal notranslate"><span class="pre">publish()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.readAIODglossary"><code class="docutils literal notranslate"><span class="pre">readAIODglossary()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.remove_dataset"><code class="docutils literal notranslate"><span class="pre">remove_dataset()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.send_dataset_to_platform"><code class="docutils literal notranslate"><span class="pre">send_dataset_to_platform()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.set_nested_value"><code class="docutils literal notranslate"><span class="pre">set_nested_value()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.translate2AIoD"><code class="docutils literal notranslate"><span class="pre">translate2AIoD()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.update_dataset_to_platform"><code class="docutils literal notranslate"><span class="pre">update_dataset_to_platform()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.update_modify_date_entry"><code class="docutils literal notranslate"><span class="pre">update_modify_date_entry()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_services.html#app.services.user_exists"><code class="docutils literal notranslate"><span class="pre">user_exists()</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../app_routing.html">Routes</a><ul>
<li class="toctree-l3"><a class="reference internal" href="../../app_routing.html#app.routes.get_dataset"><code class="docutils literal notranslate"><span class="pre">get_dataset()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_routing.html#app.routes.index"><code class="docutils literal notranslate"><span class="pre">index()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_routing.html#app.routes.login"><code class="docutils literal notranslate"><span class="pre">login()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_routing.html#app.routes.publish"><code class="docutils literal notranslate"><span class="pre">publish()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="../../app_routing.html#app.routes.translate_metadata"><code class="docutils literal notranslate"><span class="pre">translate_metadata()</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">AIoD Broker</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content style-external-links">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../index.html">Module code</a></li>
      <li class="breadcrumb-item active">app.services</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for app.services</h1><div class="highlight"><pre>
<span></span><span class="c1"># MIT License</span>

<span class="c1"># Copyright (c) 2024 University College Cork</span>

<span class="c1"># Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<span class="c1"># of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<span class="c1"># in the Software without restriction, including without limitation the rights</span>
<span class="c1"># to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<span class="c1"># copies of the Software, and to permit persons to whom the Software is</span>
<span class="c1"># furnished to do so, subject to the following conditions:</span>

<span class="c1"># The above copyright notice and this permission notice shall be included in all</span>
<span class="c1"># copies or substantial portions of the Software.</span>

<span class="c1"># THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<span class="c1"># IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<span class="c1"># FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<span class="c1"># AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<span class="c1"># LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<span class="c1"># OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE</span>
<span class="c1"># SOFTWARE.</span>

<span class="kn">from</span> <span class="nn">app.models</span> <span class="kn">import</span> <span class="n">db</span><span class="p">,</span> <span class="n">Dataset</span>
<span class="kn">from</span> <span class="nn">datetime</span> <span class="kn">import</span> <span class="n">datetime</span>
<span class="kn">from</span> <span class="nn">app</span> <span class="kn">import</span> <span class="n">app</span>
<span class="kn">import</span> <span class="nn">random</span>
<span class="kn">import</span> <span class="nn">string</span>
<span class="kn">import</span> <span class="nn">json</span>
<span class="kn">import</span> <span class="nn">requests</span>
<span class="kn">from</span> <span class="nn">dateutil</span> <span class="kn">import</span> <span class="n">parser</span>
<span class="kn">from</span> <span class="nn">keycloak</span> <span class="kn">import</span> <span class="n">KeycloakOpenID</span><span class="p">,</span> <span class="n">KeycloakAuthenticationError</span><span class="p">,</span> <span class="n">ConnectionManager</span><span class="p">,</span> <span class="n">KeycloakPostError</span>
<span class="kn">from</span> <span class="nn">jsonpath_ng</span> <span class="kn">import</span> <span class="n">parse</span> 


<span class="c1"># -------- Tools -------- </span>

<span class="c1"># Returns a KeycloakOpenID object</span>
<span class="k">def</span> <span class="nf">_connect_keycloak</span><span class="p">()</span> <span class="o">-&gt;</span> <span class="n">KeycloakOpenID</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Returns a KeycloakOpenID object.</span>

<span class="sd">    Returns:</span>
<span class="sd">        KeycloakOpenID: A KeycloakOpenID object.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">KeycloakOpenID</span><span class="p">(</span>
        <span class="n">server_url</span><span class="o">=</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s2">&quot;API_URL&quot;</span><span class="p">]</span><span class="o">+</span><span class="s2">&quot;/aiod-auth/&quot;</span><span class="p">,</span>
        <span class="n">client_id</span><span class="o">=</span><span class="s2">&quot;aiod-api-swagger&quot;</span><span class="p">,</span>
        <span class="n">realm_name</span><span class="o">=</span><span class="s2">&quot;aiod&quot;</span><span class="p">,</span>
    <span class="p">)</span>

<span class="c1"># Connects to Keycloak server.</span>
<div class="viewcode-block" id="keycloak_openid">
<a class="viewcode-back" href="../../app_services.html#app.services.keycloak_openid">[docs]</a>
<span class="k">def</span> <span class="nf">keycloak_openid</span><span class="p">()</span> <span class="o">-&gt;</span> <span class="n">KeycloakOpenID</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Connects to Keycloak server.</span>

<span class="sd">    Returns:</span>
<span class="sd">        KeycloakOpenID: A KeycloakOpenID object.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">global</span> <span class="n">_keycloak_openid</span>
    <span class="k">if</span> <span class="n">_keycloak_openid</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">_keycloak_openid</span> <span class="o">=</span> <span class="n">_connect_keycloak</span><span class="p">()</span>
    <span class="k">return</span> <span class="n">_keycloak_openid</span></div>


<span class="n">_keycloak_openid</span><span class="p">:</span> <span class="n">KeycloakOpenID</span> <span class="o">|</span> <span class="kc">None</span> <span class="o">=</span> <span class="kc">None</span>

<span class="c1"># Generates a random ID string.</span>
<div class="viewcode-block" id="generate_string">
<a class="viewcode-back" href="../../app_services.html#app.services.generate_string">[docs]</a>
<span class="k">def</span> <span class="nf">generate_string</span><span class="p">(</span><span class="n">length</span><span class="p">:</span><span class="nb">int</span><span class="o">=</span><span class="mi">32</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">str</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Generates a random ID string.</span>

<span class="sd">    Args:</span>
<span class="sd">        length (int): The number of characters that the ID will have (default value = 32).</span>

<span class="sd">    Returns:</span>
<span class="sd">        str: The ID in string format.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="s1">&#39;&#39;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">random</span><span class="o">.</span><span class="n">choices</span><span class="p">(</span><span class="n">string</span><span class="o">.</span><span class="n">ascii_letters</span> <span class="o">+</span> <span class="n">string</span><span class="o">.</span><span class="n">digits</span><span class="p">,</span> <span class="n">k</span><span class="o">=</span><span class="n">length</span><span class="p">))</span></div>



<span class="c1"># ------ Functions ------ </span>

<span class="c1"># Returns a dictionary that contains the access/refresh tokens.</span>
<div class="viewcode-block" id="login">
<a class="viewcode-back" href="../../app_services.html#app.services.login">[docs]</a>
<span class="k">def</span> <span class="nf">login</span><span class="p">(</span><span class="n">username</span><span class="p">:</span><span class="nb">str</span><span class="p">,</span> <span class="n">password</span><span class="p">:</span><span class="nb">str</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">dict</span> <span class="o">|</span> <span class="kc">None</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Returns a dictionary that contains the access/refresh tokens.</span>
<span class="sd">    </span>
<span class="sd">    Args:</span>
<span class="sd">        username (str): The username.</span>
<span class="sd">        password (str): The password.</span>

<span class="sd">    Returns:</span>
<span class="sd">        dict: The access/refresh token.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">token</span> <span class="o">=</span> <span class="n">keycloak_openid</span><span class="p">()</span><span class="o">.</span><span class="n">token</span><span class="p">(</span><span class="n">username</span><span class="p">,</span> <span class="n">password</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">token</span> 
    <span class="k">except</span><span class="p">:</span>
        <span class="k">return</span> <span class="kc">None</span>    </div>


<span class="c1"># Checks if the user exists in the config users table.</span>
<div class="viewcode-block" id="user_exists">
<a class="viewcode-back" href="../../app_services.html#app.services.user_exists">[docs]</a>
<span class="k">def</span> <span class="nf">user_exists</span><span class="p">(</span><span class="n">users</span><span class="p">:</span><span class="nb">list</span><span class="p">,</span> <span class="n">username</span><span class="p">:</span><span class="nb">str</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">dict</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Checks if the user exists in the config users table.</span>
<span class="sd">    </span>
<span class="sd">    Args:</span>
<span class="sd">        user (list): The list of users&#39; records.</span>
<span class="sd">        username (str): The username to be checked whether is in the list.</span>

<span class="sd">    Returns:</span>
<span class="sd">        dict: A dictionary with a field called status that is True if the user exists and False otherwise, </span>
<span class="sd">              along with a field called object that contains the user&#39;s record in the database.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">user</span> <span class="ow">in</span> <span class="n">users</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">user</span><span class="p">[</span><span class="s2">&quot;username&quot;</span><span class="p">]</span> <span class="o">==</span> <span class="n">username</span><span class="p">:</span>
            <span class="k">return</span> <span class="p">{</span><span class="s2">&quot;status&quot;</span><span class="p">:</span><span class="kc">True</span><span class="p">,</span><span class="s2">&quot;object&quot;</span><span class="p">:</span><span class="n">user</span><span class="p">}</span> 
    <span class="k">return</span> <span class="p">{</span><span class="s2">&quot;status&quot;</span><span class="p">:</span><span class="kc">False</span><span class="p">,</span><span class="s2">&quot;object&quot;</span><span class="p">:{}}</span> </div>


<span class="c1"># Reads the glossary file for the AIOD/DATAMITE translation.</span>
<div class="viewcode-block" id="readAIODglossary">
<a class="viewcode-back" href="../../app_services.html#app.services.readAIODglossary">[docs]</a>
<span class="k">def</span> <span class="nf">readAIODglossary</span><span class="p">()</span> <span class="o">-&gt;</span> <span class="nb">list</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Reads the glossary file for the AIOD/DATAMITE translation.</span>

<span class="sd">    Returns:</span>
<span class="sd">        list: The glossary object.</span>

<span class="sd">    &quot;&quot;&quot;</span>
    
    <span class="n">f</span> <span class="o">=</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;files/datamite_aiod_glossary.json&#39;</span><span class="p">)</span>
    <span class="n">glossary</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">glossary</span></div>


<span class="c1"># Translates the input metadata according to the provided AIoD&#39;s glossary.</span>
<div class="viewcode-block" id="translate2AIoD">
<a class="viewcode-back" href="../../app_services.html#app.services.translate2AIoD">[docs]</a>
<span class="k">def</span> <span class="nf">translate2AIoD</span><span class="p">(</span><span class="n">metadata</span><span class="p">:</span><span class="nb">dict</span><span class="p">,</span> <span class="n">glossary</span><span class="p">:</span><span class="nb">list</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">list</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Translates the input metadata according to the provided AIoD&#39;s glossary.</span>
<span class="sd">    </span>
<span class="sd">    Args:</span>
<span class="sd">        metadata (dict): The metadata of Datamite&#39;s schema.</span>
<span class="sd">        glossary (dict): The glossary for the translation.</span>

<span class="sd">    Returns:</span>
<span class="sd">        list: A list of dictionaries with a field called payload that contains a list of dictionaries. </span>
<span class="sd">              The nested dictionaries have the following fields:</span>
<span class="sd">              - attribute (str): The name of the attribute.</span>
<span class="sd">              - type (str): the type of the attribute.</span>
<span class="sd">              - value (depending on the attribute): the value of the attribute.</span>
<span class="sd">              - mandatory (boolean): Whether it is mandatory or not.</span>
<span class="sd">              - description (str): A description of the attribute.</span>
<span class="sd">              - example (depending on the attribute): An example value of the attribute.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">new_metadata</span> <span class="o">=</span> <span class="p">[]</span>

    <span class="k">for</span> <span class="n">dataset</span> <span class="ow">in</span> <span class="n">metadata</span><span class="p">[</span><span class="s2">&quot;entity&quot;</span><span class="p">][</span><span class="s2">&quot;datasets&quot;</span><span class="p">]:</span>
        <span class="n">payload</span><span class="o">=</span><span class="p">[]</span>
        <span class="k">for</span> <span class="n">rule</span> <span class="ow">in</span> <span class="n">glossary</span><span class="p">:</span>

            <span class="n">attribute</span> <span class="o">=</span> <span class="n">rule</span><span class="p">[</span><span class="s1">&#39;attribute&#39;</span><span class="p">]</span>
            <span class="n">translation</span> <span class="o">=</span> <span class="n">rule</span><span class="p">[</span><span class="s1">&#39;translation&#39;</span><span class="p">]</span>
            <span class="n">default_value</span> <span class="o">=</span> <span class="n">rule</span><span class="p">[</span><span class="s1">&#39;default&#39;</span><span class="p">]</span>
            <span class="n">value_type</span> <span class="o">=</span> <span class="n">rule</span><span class="p">[</span><span class="s1">&#39;type&#39;</span><span class="p">]</span>
            <span class="n">mandatory</span> <span class="o">=</span> <span class="n">rule</span><span class="p">[</span><span class="s1">&#39;mandatory&#39;</span><span class="p">]</span>
            <span class="n">description</span> <span class="o">=</span> <span class="n">rule</span><span class="p">[</span><span class="s1">&#39;description&#39;</span><span class="p">]</span>
            <span class="n">example</span> <span class="o">=</span> <span class="n">rule</span><span class="p">[</span><span class="s1">&#39;example&#39;</span><span class="p">]</span>

            <span class="k">if</span> <span class="p">(</span><span class="n">translation</span><span class="o">==</span><span class="s2">&quot;&quot;</span><span class="p">):</span>
                <span class="n">val</span> <span class="o">=</span> <span class="n">default_value</span>
            <span class="k">else</span><span class="p">:</span>

                <span class="n">jsonpath_expr</span> <span class="o">=</span> <span class="n">parse</span><span class="p">(</span><span class="n">translation</span><span class="p">)</span>
                <span class="n">match</span> <span class="o">=</span> <span class="n">jsonpath_expr</span><span class="o">.</span><span class="n">find</span><span class="p">(</span><span class="n">dataset</span><span class="p">)</span>

                <span class="k">if</span> <span class="n">match</span><span class="p">:</span>
                    <span class="n">value</span> <span class="o">=</span> <span class="n">match</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">value</span>
                    <span class="n">val</span> <span class="o">=</span> <span class="n">value</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">value</span> <span class="o">=</span> <span class="n">default_value</span>
                    <span class="n">val</span> <span class="o">=</span> <span class="n">default_value</span>

            <span class="k">if</span> <span class="p">(</span><span class="n">value_type</span> <span class="o">==</span> <span class="s2">&quot;datetime&quot;</span><span class="p">):</span>
                <span class="n">val</span><span class="o">=</span><span class="n">convert_date_to_iso_format</span><span class="p">(</span><span class="n">val</span><span class="p">)</span>

            <span class="k">if</span> <span class="p">(</span><span class="n">attribute</span> <span class="o">==</span> <span class="s2">&quot;distribution&quot;</span><span class="p">):</span>
                <span class="n">val</span><span class="p">[</span><span class="s1">&#39;content_url&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">val</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="s1">&#39;accessUrl&#39;</span><span class="p">)</span>
                <span class="n">val</span><span class="o">=</span><span class="p">[</span><span class="n">val</span><span class="p">]</span>

            <span class="n">payload</span><span class="o">.</span><span class="n">append</span><span class="p">({</span>
                <span class="s2">&quot;attribute&quot;</span><span class="p">:</span> <span class="n">attribute</span><span class="p">,</span>
                <span class="s2">&quot;type&quot;</span> <span class="p">:</span> <span class="n">value_type</span><span class="p">,</span>
                <span class="s2">&quot;value&quot;</span><span class="p">:</span> <span class="n">val</span><span class="p">,</span>
                <span class="s2">&quot;mandatory&quot;</span> <span class="p">:</span> <span class="n">mandatory</span><span class="p">,</span>
                <span class="s2">&quot;description&quot;</span> <span class="p">:</span> <span class="n">description</span><span class="p">,</span>
                <span class="s2">&quot;example&quot;</span> <span class="p">:</span> <span class="n">example</span>
            <span class="p">})</span>

        <span class="n">new_metadata</span><span class="o">.</span><span class="n">append</span><span class="p">({</span>
            <span class="s2">&quot;payload&quot;</span><span class="p">:</span><span class="n">payload</span><span class="p">,</span>
        <span class="p">})</span>

    <span class="k">return</span> <span class="n">new_metadata</span></div>


<span class="c1"># Converts a date string to ISO 8601 format.</span>
<div class="viewcode-block" id="convert_date_to_iso_format">
<a class="viewcode-back" href="../../app_services.html#app.services.convert_date_to_iso_format">[docs]</a>
<span class="k">def</span> <span class="nf">convert_date_to_iso_format</span><span class="p">(</span><span class="n">date_str</span><span class="p">:</span><span class="nb">str</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">str</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Converts a date string to ISO 8601 format.</span>
<span class="sd">    </span>
<span class="sd">    Args:</span>
<span class="sd">        date_str (str): The date in string format.</span>
<span class="sd">        </span>
<span class="sd">    Returns:</span>
<span class="sd">        str: The date in ISO 8601 format.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">dt</span> <span class="o">=</span> <span class="n">parser</span><span class="o">.</span><span class="n">parse</span><span class="p">(</span><span class="n">date_str</span><span class="p">)</span>    
    <span class="n">formatted_date</span> <span class="o">=</span> <span class="n">dt</span><span class="o">.</span><span class="n">strftime</span><span class="p">(</span><span class="s2">&quot;%Y-%m-</span><span class="si">%d</span><span class="s2">T%H:%M:%S.</span><span class="si">%f</span><span class="s2">&quot;</span><span class="p">)[:</span><span class="o">-</span><span class="mi">3</span><span class="p">]</span>
    
    <span class="k">return</span> <span class="n">formatted_date</span></div>


<span class="c1"># Handles publish functionality depending on whether the dataset is new or old.</span>
<div class="viewcode-block" id="publish">
<a class="viewcode-back" href="../../app_services.html#app.services.publish">[docs]</a>
<span class="k">def</span> <span class="nf">publish</span><span class="p">(</span><span class="n">data</span><span class="p">:</span><span class="nb">dict</span><span class="p">,</span> <span class="n">token</span><span class="p">:</span><span class="nb">dict</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">list</span><span class="p">:</span> 
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Handles publish functionality depending on whether the dataset is new or old.</span>
<span class="sd">    </span>
<span class="sd">    Args:</span>
<span class="sd">        data (dict): A dicitionary with fields datasets which contains a list of the translated-to-AIoD metadata for the different datasets</span>
<span class="sd">                     and user which contains a dicitonary with field username:user and id:user-id.</span>
<span class="sd">        token (dict): A dictionary that contains the access/refresh tokens.</span>

<span class="sd">    Returns:</span>
<span class="sd">        list: Contains the responses in dictionary format of the POST method for each dataset.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">responses</span><span class="o">=</span><span class="p">[]</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">data</span><span class="p">[</span><span class="s2">&quot;datasets&quot;</span><span class="p">])):</span>

        <span class="n">single_dataset</span> <span class="o">=</span> <span class="n">data</span><span class="p">[</span><span class="s2">&quot;datasets&quot;</span><span class="p">][</span><span class="n">i</span><span class="p">]</span>
        <span class="n">payload</span><span class="o">=</span><span class="n">parse2payload</span><span class="p">(</span><span class="n">single_dataset</span><span class="p">)</span>
        <span class="n">dataset</span> <span class="o">=</span>  <span class="n">get_platform_id_by_dataset_name</span><span class="p">(</span><span class="n">payload</span><span class="p">[</span><span class="s2">&quot;name&quot;</span><span class="p">])</span>
        <span class="k">if</span> <span class="p">(</span><span class="n">dataset</span> <span class="o">==</span> <span class="kc">None</span><span class="p">):</span>
            <span class="n">resp</span> <span class="o">=</span> <span class="n">send_dataset_to_platform</span><span class="p">(</span><span class="n">payload</span><span class="p">,</span><span class="n">token</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">resp</span> <span class="o">=</span> <span class="n">update_dataset_to_platform</span><span class="p">(</span><span class="n">payload</span><span class="p">,</span><span class="n">token</span><span class="p">,</span><span class="n">dataset</span><span class="p">)</span>
        <span class="n">responses</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">resp</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">responses</span></div>


<span class="c1"># Fetches the datasets (in AIoD metadata schema) from the AIoD by using the AIoD API.</span>
<div class="viewcode-block" id="fetch_dataset">
<a class="viewcode-back" href="../../app_services.html#app.services.fetch_dataset">[docs]</a>
<span class="k">def</span> <span class="nf">fetch_dataset</span><span class="p">(</span><span class="n">dataset_ids</span><span class="p">:</span><span class="nb">list</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">dict</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Fetches the datasets (in AIoD metadata schema) from the AIoD by using the AIoD API.</span>
<span class="sd">    </span>
<span class="sd">    Args:</span>
<span class="sd">        dataset_ids (list): Containts the ids of the datasets to be fetched.</span>
<span class="sd">        </span>
<span class="sd">    Returns:</span>
<span class="sd">        dict: A dictionary with a field response which contains a list of the AIoD metadata for each requested dataset.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">resp</span><span class="o">=</span><span class="p">[]</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">dataset_ids</span><span class="p">)):</span>
        <span class="n">path</span><span class="o">=</span><span class="s2">&quot;/datasets/v1/&quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">dataset_ids</span><span class="p">[</span><span class="n">i</span><span class="p">])</span><span class="o">+</span><span class="s2">&quot;?schema=aiod&quot;</span>
        <span class="n">url</span> <span class="o">=</span> <span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s2">&quot;API_URL&quot;</span><span class="p">]</span><span class="o">+</span><span class="n">path</span>

        <span class="n">response</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">url</span><span class="p">)</span>
        <span class="n">resp</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">response</span><span class="o">.</span><span class="n">json</span><span class="p">())</span>

    <span class="k">return</span> <span class="p">{</span><span class="s2">&quot;response&quot;</span><span class="p">:</span><span class="n">resp</span><span class="p">}</span></div>


<span class="c1"># Adds a new dataset entry to the AIoD platform and the local database.</span>
<div class="viewcode-block" id="send_dataset_to_platform">
<a class="viewcode-back" href="../../app_services.html#app.services.send_dataset_to_platform">[docs]</a>
<span class="k">def</span> <span class="nf">send_dataset_to_platform</span><span class="p">(</span><span class="n">payload</span><span class="p">:</span><span class="nb">dict</span><span class="p">,</span><span class="n">token</span><span class="p">:</span><span class="nb">dict</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">dict</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Adds a new dataset entry to the AIoD platform and the local database.</span>
<span class="sd">    </span>
<span class="sd">    Args:</span>
<span class="sd">        payload (dict): A dictionary with the tranlated metadata in the AIoD schema.</span>
<span class="sd">        token (dict): A dictionary contains the access/refresh token.</span>

<span class="sd">    Returns:</span>
<span class="sd">        dict: A dictionary with fields status and the AIoD&#39;s dataset identifier.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># define platform and API URL</span>
    <span class="n">platform_name</span><span class="o">=</span><span class="s2">&quot;example&quot;</span>
    <span class="n">path</span><span class="o">=</span><span class="s2">&quot;/datasets/v1&quot;</span>
    <span class="n">url</span> <span class="o">=</span> <span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s2">&quot;API_URL&quot;</span><span class="p">]</span><span class="o">+</span><span class="n">path</span>

    <span class="c1"># generate new id</span>
    <span class="n">dataset_identifier</span> <span class="o">=</span> <span class="n">generate_string</span><span class="p">(</span><span class="n">length</span><span class="o">=</span><span class="mi">63</span><span class="p">)</span>

    <span class="c1"># add entries to platform identifier to payload</span>
    <span class="n">payload</span><span class="p">[</span><span class="s2">&quot;platform&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">platform_name</span>
    <span class="n">payload</span><span class="p">[</span><span class="s2">&quot;platform_resource_identifier&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">dataset_identifier</span>

    <span class="c1"># define token header</span>
    <span class="n">headers</span> <span class="o">=</span> <span class="p">{</span>
        <span class="s2">&quot;Authorization&quot;</span><span class="p">:</span> <span class="s2">&quot;Bearer &quot;</span><span class="o">+</span><span class="n">token</span><span class="p">[</span><span class="s2">&quot;access_token&quot;</span><span class="p">]</span>
    <span class="p">}</span>

    <span class="c1"># send post request to eu platform</span>
    <span class="n">response</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">post</span><span class="p">(</span><span class="n">url</span><span class="p">,</span> <span class="n">json</span><span class="o">=</span><span class="n">payload</span><span class="p">,</span> <span class="n">headers</span><span class="o">=</span><span class="n">headers</span><span class="p">)</span>
    <span class="n">resp</span><span class="o">=</span><span class="n">response</span><span class="o">.</span><span class="n">json</span><span class="p">()</span>
    <span class="n">resp</span><span class="p">[</span><span class="s2">&quot;status&quot;</span><span class="p">]</span><span class="o">=</span><span class="s2">&quot;Created&quot;</span>

    <span class="c1"># add dataset to database</span>
    <span class="n">add_dataset</span><span class="p">(</span><span class="n">dataset_identifier</span><span class="p">,</span> <span class="n">payload</span><span class="p">[</span><span class="s2">&quot;name&quot;</span><span class="p">],</span> <span class="n">resp</span><span class="p">[</span><span class="s2">&quot;identifier&quot;</span><span class="p">])</span>

    <span class="k">return</span> <span class="n">resp</span></div>


<span class="c1"># Updates a pre-existing dataset entry to the AIoD portal and the local database.</span>
<div class="viewcode-block" id="update_dataset_to_platform">
<a class="viewcode-back" href="../../app_services.html#app.services.update_dataset_to_platform">[docs]</a>
<span class="k">def</span> <span class="nf">update_dataset_to_platform</span><span class="p">(</span><span class="n">payload</span><span class="p">:</span><span class="nb">dict</span><span class="p">,</span><span class="n">token</span><span class="p">:</span><span class="nb">dict</span><span class="p">,</span><span class="n">dataset</span><span class="p">:</span><span class="nb">dict</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">dict</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Updates a pre-existing dataset entry to the AIoD portal and the local database.</span>
<span class="sd">    </span>
<span class="sd">    Args:</span>
<span class="sd">        payload (dict): A dictionary with the tranlated metadata in the AIoD schema.</span>
<span class="sd">        token (dict): A dictionary that containts the access/refresh token.</span>
<span class="sd">        dateset (dict): The metadata to be updated.</span>

<span class="sd">    Returns:</span>
<span class="sd">        dict: A dictionary with fields status and the AIoD&#39;s dataset identifier.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">resp</span><span class="o">=</span><span class="p">[]</span>
    
    <span class="c1"># define platform and API URL</span>
    <span class="n">platform_name</span><span class="o">=</span><span class="s2">&quot;example&quot;</span>
    <span class="n">path</span><span class="o">=</span><span class="s2">&quot;/datasets/v1/&quot;</span><span class="o">+</span><span class="n">dataset</span><span class="p">[</span><span class="s2">&quot;platform_id&quot;</span><span class="p">]</span>
    <span class="n">url</span> <span class="o">=</span> <span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s2">&quot;API_URL&quot;</span><span class="p">]</span><span class="o">+</span><span class="n">path</span>

    <span class="c1"># generate new id</span>
    <span class="n">dataset_identifier</span> <span class="o">=</span> <span class="n">dataset</span><span class="p">[</span><span class="s2">&quot;id&quot;</span><span class="p">]</span>

    <span class="c1"># add entries to platform identifier to payload</span>
    <span class="n">payload</span><span class="p">[</span><span class="s2">&quot;platform&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">platform_name</span>
    <span class="n">payload</span><span class="p">[</span><span class="s2">&quot;platform_resource_identifier&quot;</span><span class="p">]</span> <span class="o">=</span> <span class="n">dataset_identifier</span>

    <span class="c1"># define token header</span>
    <span class="n">headers</span> <span class="o">=</span> <span class="p">{</span>
        <span class="s2">&quot;Authorization&quot;</span><span class="p">:</span> <span class="s2">&quot;Bearer &quot;</span><span class="o">+</span><span class="n">token</span><span class="p">[</span><span class="s2">&quot;access_token&quot;</span><span class="p">]</span>
    <span class="p">}</span>

    <span class="c1"># send put request to eu platform</span>
    <span class="n">response</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">put</span><span class="p">(</span><span class="n">url</span><span class="p">,</span> <span class="n">json</span><span class="o">=</span><span class="n">payload</span><span class="p">,</span> <span class="n">headers</span><span class="o">=</span><span class="n">headers</span><span class="p">)</span>
    <span class="n">resp</span><span class="o">=</span><span class="p">{</span>
        <span class="s2">&quot;identifier&quot;</span><span class="p">:</span><span class="n">dataset</span><span class="p">[</span><span class="s2">&quot;platform_id&quot;</span><span class="p">],</span>
        <span class="s2">&quot;status&quot;</span><span class="p">:</span><span class="s2">&quot;Updated&quot;</span>
    <span class="p">}</span>

    <span class="c1"># update modify_date entry in local db</span>
    <span class="n">update_modify_date_entry</span><span class="p">(</span><span class="n">dataset_identifier</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">resp</span></div>


<span class="c1"># Parses the received list of dicitonaries to the appropriate AIoD payload format.</span>
<div class="viewcode-block" id="parse2payload">
<a class="viewcode-back" href="../../app_services.html#app.services.parse2payload">[docs]</a>
<span class="k">def</span> <span class="nf">parse2payload</span><span class="p">(</span><span class="n">data</span><span class="p">:</span><span class="nb">list</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">dict</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Parses the received list of dicitonaries to the appropriate AIoD payload format.</span>
<span class="sd">    </span>
<span class="sd">    Args:</span>
<span class="sd">        data (list): Contains dictionaries with the following format:</span>
<span class="sd">                    - attribute (str): The name of the attribute.</span>
<span class="sd">                    - type (str): the type of the attribute.</span>
<span class="sd">                    - value (depending on the attribute): the value of the attribute.</span>
<span class="sd">                    - mandatory (boolean): Whether it is mandatory or not.</span>
<span class="sd">                    - description (str): A description of the attribute.</span>
<span class="sd">                    - example (depending on the attribute): An example value of the attribute.</span>
<span class="sd">        </span>
<span class="sd">    Returns:</span>
<span class="sd">        dict: A dictionary in the AIoD payload format.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">payload</span><span class="o">=</span><span class="p">{}</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">data</span><span class="p">)):</span>

        <span class="n">keys</span> <span class="o">=</span> <span class="n">data</span><span class="p">[</span><span class="n">i</span><span class="p">][</span><span class="s2">&quot;attribute&quot;</span><span class="p">]</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;.&quot;</span><span class="p">)</span>
        <span class="n">value</span> <span class="o">=</span> <span class="n">data</span><span class="p">[</span><span class="n">i</span><span class="p">][</span><span class="s2">&quot;value&quot;</span><span class="p">]</span>
        <span class="n">set_nested_value</span><span class="p">(</span><span class="n">payload</span><span class="p">,</span> <span class="n">keys</span><span class="p">,</span> <span class="n">value</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">payload</span></div>


<span class="c1"># Parses the received dictionary to the appropriate AIoD payload format.</span>
<div class="viewcode-block" id="set_nested_value">
<a class="viewcode-back" href="../../app_services.html#app.services.set_nested_value">[docs]</a>
<span class="k">def</span> <span class="nf">set_nested_value</span><span class="p">(</span><span class="n">d</span><span class="p">:</span><span class="nb">dict</span><span class="p">,</span> <span class="n">keys</span><span class="p">:</span><span class="nb">list</span><span class="p">,</span> <span class="n">value</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Parses the received dictionary to the appropriate AIoD payload format.</span>
<span class="sd">    </span>
<span class="sd">    Args:</span>
<span class="sd">        d (dict): The return dictionary (default empty).</span>
<span class="sd">        keys (list): A list of attributes.</span>
<span class="sd">        values (str | dict | list | float | int | boolean): The target value.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">keys</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">]:</span>
        <span class="k">if</span> <span class="n">key</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">d</span><span class="p">:</span>
            <span class="n">d</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="n">d</span> <span class="o">=</span> <span class="n">d</span><span class="p">[</span><span class="n">key</span><span class="p">]</span>
    <span class="n">d</span><span class="p">[</span><span class="n">keys</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]]</span> <span class="o">=</span> <span class="n">value</span></div>


<span class="c1"># Adds a dataset to the database.</span>
<div class="viewcode-block" id="add_dataset">
<a class="viewcode-back" href="../../app_services.html#app.services.add_dataset">[docs]</a>
<span class="k">def</span> <span class="nf">add_dataset</span><span class="p">(</span><span class="n">identifier</span><span class="p">:</span><span class="nb">str</span><span class="p">,</span> <span class="n">Dataset_name</span><span class="p">:</span><span class="nb">str</span><span class="p">,</span> <span class="n">platform_identifier</span><span class="p">:</span><span class="nb">str</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Adds a dataset to the database.</span>
<span class="sd">    </span>
<span class="sd">    Args:</span>
<span class="sd">        identifier (str): The identifier of the dataset.</span>
<span class="sd">        Dataset_name (str): The name of the dataset.</span>
<span class="sd">        platform_identifier (str): The identifier of the AIoD platform.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># get date-time on string format</span>
    <span class="n">now</span><span class="o">=</span><span class="n">datetime</span><span class="o">.</span><span class="n">now</span><span class="p">()</span><span class="o">.</span><span class="n">strftime</span><span class="p">(</span><span class="s2">&quot;</span><span class="si">%d</span><span class="s2">/%m/%Y, %H:%M:%S&quot;</span><span class="p">)</span>

    <span class="n">dataset</span> <span class="o">=</span> <span class="n">Dataset</span><span class="p">(</span><span class="nb">id</span><span class="o">=</span><span class="n">identifier</span><span class="p">,</span><span class="n">name</span><span class="o">=</span><span class="n">Dataset_name</span><span class="p">,</span><span class="n">platform_id</span><span class="o">=</span><span class="n">platform_identifier</span><span class="p">,</span><span class="n">create_date</span><span class="o">=</span><span class="n">now</span><span class="p">,</span><span class="n">modify_date</span><span class="o">=</span><span class="n">now</span><span class="p">)</span>
    <span class="n">db</span><span class="o">.</span><span class="n">session</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">dataset</span><span class="p">)</span>
    <span class="n">db</span><span class="o">.</span><span class="n">session</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span></div>


<span class="c1"># Removes a dataset from the database using the ID.</span>
<div class="viewcode-block" id="remove_dataset">
<a class="viewcode-back" href="../../app_services.html#app.services.remove_dataset">[docs]</a>
<span class="k">def</span> <span class="nf">remove_dataset</span><span class="p">(</span><span class="n">dataset_id</span><span class="p">:</span><span class="nb">str</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">int</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Removes a dataset from the database using the ID.</span>
<span class="sd">    </span>
<span class="sd">    Args:</span>
<span class="sd">        dataset_id (str): The identifier of the dataset.</span>
<span class="sd">        </span>
<span class="sd">    Returns:</span>
<span class="sd">        int: 1 if the dataset existed and was successfully deleted, 0 otherwise. </span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">dataset</span> <span class="o">=</span> <span class="n">Dataset</span><span class="o">.</span><span class="n">query</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">dataset_id</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">dataset</span><span class="p">:</span>
        <span class="n">db</span><span class="o">.</span><span class="n">session</span><span class="o">.</span><span class="n">delete</span><span class="p">(</span><span class="n">dataset</span><span class="p">)</span>
        <span class="n">db</span><span class="o">.</span><span class="n">session</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
        <span class="k">return</span> <span class="mi">1</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="mi">0</span></div>


<span class="c1"># Returns the platform_id and the id of a dataset within the database with a specific name.</span>
<div class="viewcode-block" id="get_platform_id_by_dataset_name">
<a class="viewcode-back" href="../../app_services.html#app.services.get_platform_id_by_dataset_name">[docs]</a>
<span class="k">def</span> <span class="nf">get_platform_id_by_dataset_name</span><span class="p">(</span><span class="n">name</span><span class="p">:</span><span class="nb">str</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">dict</span> <span class="o">|</span> <span class="kc">None</span><span class="p">:</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Returns the platform_id and the id of a dataset within the database with a specific name.</span>
<span class="sd">    </span>
<span class="sd">    Args: </span>
<span class="sd">        name (str): The name of the dataset.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>
<span class="sd">        dict: A dictionary with two fields platformd_id and id. </span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># Query the dataset by name</span>
    <span class="n">dataset</span> <span class="o">=</span> <span class="n">db</span><span class="o">.</span><span class="n">session</span><span class="o">.</span><span class="n">query</span><span class="p">(</span><span class="n">Dataset</span><span class="p">)</span><span class="o">.</span><span class="n">filter</span><span class="p">(</span><span class="n">Dataset</span><span class="o">.</span><span class="n">name</span> <span class="o">==</span> <span class="n">name</span><span class="p">)</span><span class="o">.</span><span class="n">first</span><span class="p">()</span>

    <span class="c1"># If the dataset exists, return its ID</span>
    <span class="k">if</span> <span class="n">dataset</span><span class="p">:</span>
        <span class="k">return</span> <span class="p">{</span><span class="s2">&quot;platform_id&quot;</span><span class="p">:</span><span class="n">dataset</span><span class="o">.</span><span class="n">platform_id</span><span class="p">,</span><span class="s2">&quot;id&quot;</span><span class="p">:</span><span class="n">dataset</span><span class="o">.</span><span class="n">id</span><span class="p">}</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">return</span> <span class="kc">None</span></div>


<span class="c1"># Updates the modify_date entry of a dataset in the database to the latest datetime (datetime:now()).</span>
<div class="viewcode-block" id="update_modify_date_entry">
<a class="viewcode-back" href="../../app_services.html#app.services.update_modify_date_entry">[docs]</a>
<span class="k">def</span> <span class="nf">update_modify_date_entry</span><span class="p">(</span><span class="n">dataset_id</span><span class="p">:</span><span class="nb">str</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Updates the modify_date entry of a dataset in the database to the latest datetime (datetime:now()).</span>
<span class="sd">    </span>
<span class="sd">    Args:</span>
<span class="sd">        dataset_id (str): the id of the dataset.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># get date-time on string format</span>
    <span class="n">now</span><span class="o">=</span><span class="n">datetime</span><span class="o">.</span><span class="n">now</span><span class="p">()</span><span class="o">.</span><span class="n">strftime</span><span class="p">(</span><span class="s2">&quot;</span><span class="si">%d</span><span class="s2">/%m/%Y, %H:%M:%S&quot;</span><span class="p">)</span>

    <span class="c1"># Query the dataset by ID</span>
    <span class="n">dataset</span> <span class="o">=</span> <span class="n">db</span><span class="o">.</span><span class="n">session</span><span class="o">.</span><span class="n">query</span><span class="p">(</span><span class="n">Dataset</span><span class="p">)</span><span class="o">.</span><span class="n">filter</span><span class="p">(</span><span class="n">Dataset</span><span class="o">.</span><span class="n">id</span> <span class="o">==</span> <span class="n">dataset_id</span><span class="p">)</span><span class="o">.</span><span class="n">first</span><span class="p">()</span>
    
    <span class="k">if</span> <span class="n">dataset</span><span class="p">:</span>
        <span class="c1"># Update the modify_date field</span>
        <span class="n">dataset</span><span class="o">.</span><span class="n">modify_date</span> <span class="o">=</span> <span class="n">now</span>
        
        <span class="c1"># Commit the changes to the database</span>
        <span class="n">db</span><span class="o">.</span><span class="n">session</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span></div>


<span class="c1"># Integration with logging tool.</span>
<div class="viewcode-block" id="logging">
<a class="viewcode-back" href="../../app_services.html#app.services.logging">[docs]</a>
<span class="k">def</span> <span class="nf">logging</span><span class="p">(</span><span class="n">dataset_ids</span><span class="p">:</span><span class="nb">list</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Integration with the logging tool.</span>
<span class="sd">   </span>
<span class="sd">    Args:</span>
<span class="sd">        dataset_id (list): A list with the id of the datasets.</span>
<span class="sd">   </span>
<span class="sd">    Returns:</span>
<span class="sd">        dict: A dictionary</span>
<span class="sd">    &quot;&quot;&quot;</span>
   
    <span class="c1"># The URL for the post request</span>
    <span class="n">path</span><span class="o">=</span><span class="s2">&quot;/metadataLog/publish&quot;</span>
    <span class="n">API_URL</span> <span class="o">=</span> <span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s2">&quot;LOGGING_SERVICE&quot;</span><span class="p">]</span> <span class="o">+</span> <span class="n">path</span>
 
    <span class="c1"># Fetch the metadata from in AIoD Schema.</span>
    <span class="n">response</span> <span class="o">=</span> <span class="n">fetch_dataset</span><span class="p">(</span><span class="n">dataset_ids</span><span class="o">=</span><span class="n">dataset_ids</span><span class="p">)[</span><span class="s2">&quot;response&quot;</span><span class="p">]</span>
   
    <span class="c1"># Create the payload for the post request.</span>
    <span class="n">payload</span> <span class="o">=</span> <span class="p">{</span>
        <span class="s2">&quot;endpointUsed&quot;</span> <span class="p">:</span> <span class="n">API_URL</span><span class="p">,</span>
        <span class="s2">&quot;catalogId&quot;</span><span class="p">:</span> <span class="n">generate_string</span><span class="p">(</span><span class="mi">36</span><span class="p">),</span>
        <span class="s2">&quot;catalogName&quot;</span><span class="p">:</span> <span class="s1">&#39;name_of_the_catalogue&#39;</span><span class="p">,</span>
        <span class="s2">&quot;providerId&quot;</span><span class="p">:</span> <span class="n">generate_string</span><span class="p">(</span><span class="mi">36</span><span class="p">),</span>
        <span class="s2">&quot;providerName&quot;</span><span class="p">:</span> <span class="s2">&quot;test_company&quot;</span><span class="p">,</span>
        <span class="s2">&quot;userToken&quot;</span><span class="p">:</span> <span class="s2">&quot;user_token&quot;</span><span class="p">,</span>
        <span class="s2">&quot;userId&quot;</span><span class="p">:</span> <span class="s2">&quot;dc57d527-0964-4146-8c4b-e50a526759fc&quot;</span><span class="p">,</span>
        <span class="s2">&quot;userName&quot;</span><span class="p">:</span> <span class="s2">&quot;userX&quot;</span><span class="p">,</span>
        <span class="s2">&quot;createdAt&quot;</span><span class="p">:</span> <span class="n">datetime</span><span class="o">.</span><span class="n">now</span><span class="p">()</span><span class="o">.</span><span class="n">strftime</span><span class="p">(</span><span class="s2">&quot;%Y-%m-</span><span class="si">%d</span><span class="s2">T%H:%M:%S.111Z&quot;</span><span class="p">),</span>
        <span class="s2">&quot;datasets&quot;</span> <span class="p">:</span> <span class="n">response</span>
    <span class="p">}</span>
   
    <span class="k">try</span><span class="p">:</span>
        <span class="c1"># Post request</span>
        <span class="n">resp</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">post</span><span class="p">(</span><span class="n">API_URL</span><span class="p">,</span> <span class="n">json</span><span class="o">=</span><span class="n">payload</span><span class="p">)</span>
    <span class="k">except</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Warning: The logging service is down.&quot;</span><span class="p">)</span></div>

</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2024 University College Cork.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>